#include "hijack.h"
int init_hijack(struct hijack*h , unsigned long orig, 
	unsigned long newaddr, int len)
{
	h->origaddr=orig;
	h->newaddr=newaddr;
	h->instrlen=len;
	h->done=0;
	return 0;
}
int undo_hijack(struct hijack *h)
{
	if (h->done) {
		memcpy((char*)h->origaddr, h->trampcode, h->instrlen);
		h->done=0;
		return 0;
	}else 
		return -1;
}
void* get_hijack_tramp(struct hijack*h)
{
	return (void*)&(h->trampcode);
}
#ifdef __i386__
int do_hijack(struct hijack *h)
{
	if (h->done)
		return -1;
	h->done=1;
	memcpy(h->trampcode, (char*)h->origaddr, h->instrlen);
	h->trampcode[h->instrlen] = 0x68;
	*(int *) (h->trampcode + h->instrlen + 1) =
	    h->origaddr + h->instrlen;
	h->trampcode[h->instrlen + 5] = 0xc3;
	*(char *) (h->origaddr) = 0x68;
	*(long *) (h->origaddr + 1) = h->newaddr;
	*(char *) (h->origaddr + 5) = 0xc3;
	return 0;
}
int do_hijack_aux(struct hijack *h, long addrstore)
{
	return do_hijack(h);
}
#endif
#ifdef __x86_64__
char JMPRIP6[]="\xff\x25\x00\x00\x00\x00";

int do_hijack_aux(struct hijack *h, long addrstore)
{
	long diff=addrstore-(long)h->origaddr-6;
	if (diff<0) diff=-diff;
	if ( h->done || (diff>>2)>(1<<29))
		return -1;
	h->done=1;
	memcpy(h->trampcode, (char*)h->origaddr, h->instrlen);
	memcpy(h->trampcode+h->instrlen, JMPRIP6, sizeof(JMPRIP6)-1);
	*(long*)(h->trampcode+h->instrlen+sizeof(JMPRIP6)-1)=
		h->origaddr + h->instrlen;

	memcpy(h->origaddr, JMPRIP6, 2);
	*(int*)(h->origaddr+2)=addrstore-(h->origaddr+6);
	*(long*)addrstore=h->newaddr;
	
	return 0;
}
int do_hijack(struct hijack *h)
{
	return do_hijack_aux(h, h->origaddr+6);
}
#endif
