#include <linux/module.h>
#include <linux/sched.h>
#include <asm/sigcontext.h>
#include "../sigframe.h"
#include "../uregs.h"
#define NULLT ((struct task_struct*)0)
#define NULLM ((struct mm_struct*)0)
#define NULLTHREAD ((struct thread_struct*)0)
int pgd_offset()
{
return &NULLM->pgd;
}
int tasks_offset()
{
return &NULLT->tasks;
}
int mm_offset()
{
return &NULLT->mm;
}
int pid_offset()
{
return &NULLT->pid;
}
int comm_offset()
{
return &NULLT->comm;
}
int start_code_offset()
{
return &NULLM->start_code;
}
int start_stack_offset()
{
return &NULLM->start_stack;
}
int vma_offset()
{
return &NULLM->mmap;
}
int thread_offset()
{
return &NULLT->thread;
}
int esp0_offset()
{
return &NULLTHREAD->esp0;
}
int task_struct_size()
{
return sizeof(struct task_struct);
}
int sigframe_size()
{
return sizeof( struct sigframe);
}
asmlinkage setup_sigret(struct uregs * u, struct sigframe *f,
  unsigned int eip, unsigned int esp)
{
memset(f, 0, sizeof(*f));
f->sc.es=u->es;
f->sc.cs=u->cs;
f->sc.ds=u->ds;
//f->sc.gs=0x33;
f->sc.gs=0;
f->sc.ss=u->oldss;
//f->sc.ss=0x7b;
f->sc.eax=u->eax;
f->sc.ebx=u->ebx;
f->sc.ecx=u->ecx;
f->sc.edx=u->edx;
f->sc.eip=eip;
f->sc.esp=esp;
}
